'FFSubmenu=Tools
'FFName=Albumaufruf

'FFSkriptName=Albumaufruf.vbs
'FFSkriptAuthor=Harald Maeckler
'FFSkriptVersion=1.02
'FFVersion=2.90.0
'FFSkriptURL=http://www.meckis-steckenpferde.de/FixFoto_Skripte.html

' ********************************************************************
' Albumaufruf (Skript fr FixFoto)
' Funktion:	'index.html' starten zum Zeigen eines Albums im Browserfenster
'
' Copyright Harald Maeckler, Dsseldorf 2011
'
'** Start Kurzbeschreibung *******************************************
' Albumaufruf / Version 1.02
' ================
' Das Skript dient zum Aufruf des mit Albummaker erzeugten Albums aus FixFoto heraus.
' Man kann whlen zwischen Albumaufruf 'aus Verzeichnis' und 'aus Bilderliste'.
'
' aus Verzeichnis
' ----------------------
' Es muss vor Aufruf des Skripts ein Computerverzeichnis aktiviert werden, welches das zu
' startende Album im Verzeichnis selbst oder in einem seiner Unterordner enthlt.
'
' Das aktuelle Computerverzeichnis und alle Unterordner werden daraufhin untersucht, ob
' es sich um einen Ordner '\web_album\album' handelt. Wenn ein solches Verzeichnis gefunden
' wird und darin die Datei 'index.html' existiert, wird 'index.html' gestartet.
'
' aus Bilderliste
' ----------------------
' Mit Bilderliste ist sowohl eine virtuelle Liste als auch eine Verzeichnisliste gemeint.
' Es muss vor Aufruf des Skripts die Bilderliste bzw. Verzeichnisliste aktiviert werden,
' aus der das zu startende Album erzeugt wurde.
'
' Es wird der im FF-Datenordner abgelegte Unterordner '\FF_ListAlben\AlbumOf_Listenname'
' daraufhin untersucht, ob es sich um einen Ordner '\album' handelt. Wenn ein solches Ver-
' zeichnis gefunden wird und darin die Datei 'index.html' existiert, wird 'index.html' 
' gestartet.
'
'
' Deinstallation
' ========
' Wird die Entfernung des Skripts gewnscht, kann mit der Tastenkombination Alt + D eine 
' Lschroutine aufgerufen werden. Nach einer Sicherheitsabfrage wird berprft, ob das 
' zugehrige zip-Archiv im Skriptordner abgelegt ist. Wenn ja, wird vor dem Lschen ange-
' boten, davon eine Sicherheitskopie an einem beliebigen Speicherort abzulegen. Dann werden
' nacheinander die Skriptdatei, die in der Registry dazugehrenden Daten und eventuelle
' Zusatzdateien gelscht. Abschlieend wird die FixFotoScript.ini bereinigt.
'
' Nach manueller Durchfhrung einer 'Automatischen Skriptkonfiguration' ist das Skript mit 
' allen Komponenten aus der FixFoto-Umgebung entfernt.
'
'
' Benutzung des Skripts auf eigene Gefahr!
'
' Copyright Harald Maeckler
'
'** Ende Kurzbeschreibung ********************************************
'
' Version 1.02 vom 24.03.2011	- jetzt auch Ausruf aus Verzeichnisliste
' Version 1.01 vom 23.03.2011	- wahlweise Aufruf aus Verzeichnis oder Bilderliste
' Version 1.00 vom 20.03.2011	- Betaversion
' ********************************************************************

Option Explicit

Dim SkriptName
const Skript = "Albumaufruf"						 		'Skriptname

Dim Kurzbeschreibung, KBvorhanden, LaengeMax, Abbruch		'Kurzbeschreibung
const ForReading = 1, ForWriting = 2
Abbruch = false

Dim SkriptKill,Antwort,TempFile	 : SkriptKill = false		'Lschroutine

Dim objFS,WshShell											'Objekte
Set objFS = CreateObject("Scripting.FileSystemObject")
Set WshShell = CreateObject("WScript.Shell")

Dim Startordner,Indexordner,Aufruf,Ordner,objFolder,objsubfolder,msg,msg1,Liste

call Start
set objFS = nothing
set WshShell = nothing
'------------------------------------------------------------------
Sub Start

on error resume next							'Kontrolle ob Skript in FF-Umgebung gestartet wurde
	FF_GetScriptPath
 	if err > 0 then
		msgbox "Das Skript funktioniert nur in der Programmumgebung von FixFoto!",vbCritical,"Abbruch"
		exit sub
	end if
on error goto 0

if objFS.FileExists(FF_GetScriptPath & "\" & Skript & ".vbs") then
	SkriptName = Skript & ".vbs"
else
	msgbox "Das Skript wurde umbenannt!",vbCritical,"Abbruch"
	exit sub
end if

'** Start Dialog Albumaufruf **
FF_AddDialog "Albumaufruf",140,30
FF_AddControl "Albumaufruf","aus Verzeichnis","BUTTON",35,10,45,11
FF_AddControl "Albumaufruf","aus Bilderliste","BUTTON",90,10,45,11
FF_AddControl "Albumaufruf","?","BUTTON",5,9,11,11
FF_AddControl "Albumaufruf","&delete","BUTTON",2,2,1,1
'** End Dialog Albumaufruf **

FF_ActivateControl "Albumaufruf","&delete"

do
	Select Case FF_ShowDialog ("Albumaufruf")
	Case "&delete"
		Antwort = msgbox("Soll das Skript " & SkriptName & vbNewline & _
						 "wirklich gelscht werden?", _
						 vbYesNo + vbQuestion,"Sicherheitsabfrage")
		if Antwort = vbYes then
			SkriptKill = true
			exit do
		end if
	Case "?"
		if not KBvorhanden then	call KurzbeschreibungLesen
		if KBvorhanden then
			call KurzbeschreibungAnzeigen
		else
			msgbox "Keine Kurzbeschreibung gefunden!",vbExclamation,"Meldung"
		end if
	Case "aus Verzeichnis"
		Startordner = FF_GetImagePath
		Indexordner = "\web_album\album"
		msg = vbNewline & vbNewLine & _
				"Es handelt sich beim aktuellen Verzeichnis" & vbNewline & _
				"mglicherweise um einen Bibliotheksnamen."
		msg1 = vbNewline & vbNewLine & _
				"Es wurde mit dem aktuellen Verzeichnis noch" & vbNewLine & _
				"kein Album erzeugt oder es wurde gelscht."
		call Index_Aufruf
		exit do
	Case "aus Bilderliste"
		Liste = FF_IListGetCurrentList
		if instr(Liste,":\") > 0 then
			Liste = replace(Liste,":",chr(126))
			Liste = replace(Liste,"\",chr(126))
		end if
		Startordner = FF_GetFFPathEx(1) & "\FF_ListAlben\AlbumOf_" & Liste
		Indexordner = "\album"
		msg = vbNewline & vbNewLine & _
				"Es wurde mit der aktuellen Bilderliste noch" & vbNewLine & _
				"kein Album erzeugt oder es wurde gelscht."
		msg1 = ""
		call Index_Aufruf
		exit do
	Case "CANCEL"
		exit do
	Case Else
	End Select
loop

FF_CloseDialog ("Albumaufruf")
if SkriptKill then	'ggf. Skript 'Ordner lschen' komplett entfernen
	call KillSkript
end if

End sub
'------------------------------------------------------------------
Sub ShowSubfolder(ByVal myfolder)

if instr(myfolder,Indexordner) > 0 then
	Ordner = myfolder
	exit sub
end if

For Each objsubfolder In myfolder.subfolders
	ShowSubfolder objSubFolder
Next

End Sub
'------------------------------------------------------------------
Sub Index_Aufruf

If not objFS.FolderExists(Startordner) Then
	msgbox "Das Startverzeichnis ist ungltig!" & msg,vbExclamation,"Abbruch"
	exit sub
end if

Set objFolder = objFS.GetFolder(Startordner)
call ShowSubfolder(objFolder)

if Ordner = "" then
	msgbox "Es wurde kein Ordner '" & Indexordner & "' gefunden!" & msg1,vbExclamation,"Abbruch"
	exit sub
end if

Aufruf = Ordner & "\index.html"
if objFS.FileExists(Aufruf) then
	WshShell.Run """" & Aufruf & """",1,false
else
	msgbox "Die Datei 'index.html' wurde nicht gefunden!" & vbNewLine & _
			"Mglicherweise wurde sie gelscht.",vbExclamation,"Abbruch"
end if

End Sub
'------------------------------------------------------------------
Sub KurzbeschreibungAnzeigen

Dim Taste
Dim TBreite	: TBreite = LaengeMax * 2.6 + 10
const THoehe = 180

const ES_READONLY = 2048
const WS_VSCROLL = 2097152

FF_AddDialog "Kurzbeschreibung",TBreite,THoehe
FF_AddControl "Kurzbeschreibung","Beschreibung","EDIT",0,0,TBreite,THoehe-20
FF_SetControlStyle "Kurzbeschreibung","Beschreibung", ES_READONLY + WS_VSCROLL
FF_AddControl "Kurzbeschreibung","OK","BUTTON",TBreite/2-15,THoehe-15,30,10

FF_SetControl "Kurzbeschreibung","Beschreibung",Kurzbeschreibung

do
	Taste = FF_ShowDialog("Kurzbeschreibung")
	if Taste = "CANCEL" or Taste = "OK" then exit do
loop
call FF_CloseDialog("Kurzbeschreibung")

End Sub
'------------------------------------------------------------------------
Sub KurzbeschreibungLesen
on error resume next
Const ForReading = 1
Dim Skript, Anfang, Ende, Zeile

Set Skript = objFS.OpenTextFile(FF_GetScriptPath & "\" & SkriptName, ForReading, False)

if err.number = 53 then
	msgbox "Wahrscheinlich wurde der Originalskriptname " & """" & SkriptName & """" & " abgendert." & vbNewLine & _
		   "Die Kurzbeschreibung kann daher nicht angezeigt werden.",vbExclamation,"Meldung"
	Abbruch = True
	exit sub
end if

Do While Skript.AtEndOfStream <> True
	Zeile = Skript.ReadLine
	
	if instr(Zeile,"** Ende Kurzbeschreibung") > 0 then Ende = true
	if Ende then exit do
	
	if Anfang then Kurzbeschreibung = Kurzbeschreibung & mid(Zeile,2) & vbNewLine
	if len(Zeile)-1 > LaengeMax then LaengeMax = len(Zeile)-1
	
	if instr(Zeile,"** Start Kurzbeschreibung") > 0 then Anfang = true
	
Loop
	
if Anfang and Ende then KBvorhanden = true
Skript.Close

End Sub
'------------------------------------------------------------------------
Sub KillSkript
'Skript mit allen Komponenten entfernen

Dim SPfad

'### FixFotoScript.ini bereinigen
TempFile = FF_GetFFPathEx(1) & "\FixFotoScript.ini"
if objFS.FileExists(TempFile) then
	call IniBereinigung
	if Abbruch then exit sub
else
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht gefunden werden." & vbNewLine & _
			"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	exit sub
end if

'### zip-Archiv auf Wunsch sichern, dann lschen
TempFile = FF_GetScriptPath & "\" & objFS.GetBaseName(Skriptname) & ".zip"
if objFS.FileExists(TempFile) then
	Antwort = msgbox("Soll das Archiv " & objFS.GetBaseName(Skriptname) & ".zip" & _
			 " gesichert werden?",vbYesNo + vbQuestion,"Sicherheitskopie")
	if Antwort = vbYes then
		SPfad = FF_EnterPath(true,"Wo soll die Sicherheitskopie angelegt werden?")
		if SPfad = "" then
			msgbox "Das Lschen des Skripts wird abgebrochen!",vbExclamation,"Hinweis"
			exit sub
		end if
		SPfad = SPfad & "\" & objFS.GetBaseName(Skriptname) & ".zip"
		objFS.CopyFile Tempfile, SPfad, true
	end if
	objFS.DeleteFile TempFile,true
end if

'### Skriptdatei lschen
TempFile = FF_GetScriptPath & "\" & Skriptname
objFS.DeleteFile TempFile,true

'### Fertigmeldung
msgbox "Das Skript" & Skriptname & vbNewLine & "wurde mit allen Komponenten gelscht!" & vbNewLine & _
	   "Es wird empfohlen die 'Automatische Skriptkonfiguration' aufzurufen.",vbExclamation,"Hinweis"

End Sub
'------------------------------------------------------------------------
Sub IniBereinigung
'FixFotoScript.ini - Bereinigung

Dim Zeile, zNr,Anfang, Ende, DateiTmp, ZielZeile, tmpString
DateiTmp =  FF_GetFFPathEx(1) & "\FixFotoScript.tmp"

'### Wo befindet sich der Eintrag zum Skript?
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if tmpString = "[Script]" then Anfang = zNr
	if tmpString = "File=.\" & Skriptname then
		Ende = zNr
		exit do	
	end if
loop 
Zeile.Close

if Ende <= Anfang then
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht bereinigt werden." & vbNewLine & _
		"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	Abbruch = true
	exit sub
end if

'### Zeilen ohne skriptbezogene Zeilen in DateiTmp bertragen
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)
Set ZielZeile  = objFS.CreateTextFile(DateiTmp, True)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if zNr < Anfang or zNr > Ende then
		ZielZeile.WriteLine tmpString
	end if
loop 

Zeile.Close
ZielZeile.Close

'### Umkopieren von DateiTmp nach FixFotoScript.ini (TempFile)
objFS.CopyFile DateiTmp, TempFile, True
objFS.DeleteFile (DateiTmp)

End Sub
'------------------------------------------------------------------------
